Блог пользователя awoo

Автор awoo, история, 5 часов назад, По-русски

1997A - Сильный пароль

Идея: BledDest

Разбор
Решение (BledDest)

1997B - Создайте три региона

Идея: BledDest

Разбор
Решение (Neon)

1997C - Четные позиции

Идея: BledDest

Разбор
Решение (adedalic)

1997D - Максимизация корня

Идея: BledDest

Разбор
Решение (Neon)

1997E - Прокачка персонажа

Идея: BledDest

Разбор
Решение 1 (awoo)
Решение 2 (awoo)

1997F - Фишки на прямой

Идея: BledDest

Разбор
Решение (BledDest)
  • Проголосовать: нравится
  • +29
  • Проголосовать: не нравится

»
4 часа назад, # |
  Проголосовать: нравится +18 Проголосовать: не нравится

Problem D can be solved in $$$O(n)$$$ with just a basic DFS. The idea is to maximize the minimum in each subtree. Submission: 273547075

  • »
    »
    4 часа назад, # ^ |
      Проголосовать: нравится 0 Проголосовать: не нравится

    just what i do.

  • »
    »
    3 часа назад, # ^ |
    Rev. 2   Проголосовать: нравится 0 Проголосовать: не нравится

    Thanks for the great solution. Can you please explain, when node==0 , why we are not using this part?

    Part
    • »
      »
      »
      2 часа назад, # ^ |
        Проголосовать: нравится 0 Проголосовать: не нравится

      You only care about the final value in the node 0(1). So you maximize the minimum in node 0's subtree(excluding node 0) and then use the operation as much as the minimum allows.

      • »
        »
        »
        »
        2 часа назад, # ^ |
          Проголосовать: нравится 0 Проголосовать: не нравится

        Thanks, Can you provide the intuition for your algo and how and why it works, I was on almost the same path for a few minutes in the contest but didn't connect much. Can you please explain>

        • »
          »
          »
          »
          »
          2 часа назад, # ^ |
          Rev. 2   Проголосовать: нравится 0 Проголосовать: не нравится

          This was my thought process. I want to use the operation on node 1 as many times as possible. The number of times I will be able to do it is equal to the minimum value in the subtree(excluding node 1) of node 1. Now to extend the logic, the maximum number of times I will be able to do it is equal to the minimum value in subtrees of node 1's children. This logic naturally looks like dynamic programming.

          DP transitions: if the value of the current node is greater than the value of $$$dp[node]$$$, we don't change anything, otherwise we use the operation while $$$a[node] < dp[node]$$$, in math words $$$dp[node] = \lfloor\frac{a[node] + dp[node]} {2} \rfloor $$$.

  • »
    »
    88 минут назад, # ^ |
      Проголосовать: нравится 0 Проголосовать: не нравится

    I created video editorial for D: Maximize the Root.

  • »
    »
    66 минут назад, # ^ |
      Проголосовать: нравится 0 Проголосовать: не нравится

    Same solution without using additional dp array: https://mirror.codeforces.com/contest/1997/submission/273543097

»
4 часа назад, # |
Rev. 2   Проголосовать: нравится 0 Проголосовать: не нравится

Why did I time out $$$O(nlog^2n)$$$ on E.

  • »
    »
    4 часа назад, # ^ |
    Rev. 2   Проголосовать: нравится -31 Проголосовать: не нравится

    I'm wondering a similar thing. Why do $$$O(n\cdot\log^4(n))$$$ solutions time out but $$$O(n \sqrt{n})$$$ solutions pass?

    $$$log^4(200000) \approx 790$$$ and $$$\sqrt{200000} \approx 447$$$. They really aren't that different. Plus, $$$\log$$$ is a tiny thing compared to square root.

»
4 часа назад, # |
Rev. 2   Проголосовать: нравится -8 Проголосовать: не нравится

I fsted D and E :(

I hope there will be strong pretests next time.

»
4 часа назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

I enjoyed all of the problems I saw in the contest

A was easy but still is a good problem for Div 2 A.

My only complaint is that for problem B, it wasn't really emphasized that there was one connected component at the start. It was there in text but the diagram had more than one component. Ideally that part would have been in bold.

For problem C, I misread the problem (which was completely my fault) and thought that the data corruption affected both random even and odd characters. If anyone has a solution to that problem I'd be interested. The greedy doesn't work as it is possible that by adding a closing bracket at your current position you stop the bracket sequence from becoming a regular bracket sequence. (Funnily enough, I actually the working code for this problem as a part of my attempt at a solution for the problem where random even and odd characters are corrupted.)

Problem D was a classic tree DP problem that I almost solved but ran out of time because of how much time I wasted on problem B and C.

Very nice and educational contest even though I completely under-performed.

»
4 часа назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

B was basically an IQ problem

  • »
    »
    3 часа назад, # ^ |
      Проголосовать: нравится +2 Проголосовать: не нравится

    Why are you so obsessed with iq? You also literally solved it in the contest.

    • »
      »
      »
      3 часа назад, # ^ |
        Проголосовать: нравится 0 Проголосовать: не нравится

      I am not so obsessed with IQ. It is just an interest of mine.

      B being an IQ problem doesn't really have to do with whether or not I solved it. It is an IQ problem because you clearly can't train for such problems. I bet you can't even find a similar problem on codeforces.

      Anyway, it seems like most div. 2 A-C are IQish problems. To me, it just felt like this B was a full-on IQ problem. I bet you could put that problem on an IQ test and no one would bat an eye.

      • »
        »
        »
        »
        3 часа назад, # ^ |
          Проголосовать: нравится 0 Проголосовать: не нравится

        Isn't your whole point that you can never reach red because your iq isn't high enough. Or am I mistaken? So if you can solve so called "IQ problems" than why can't you reach red?

        Also I think that your claim that you can't train for such problems is clearly ridiculous. Many GMs were stuck at Newbie for months and couldn't solve div.2 A-C. Has their IQ changed?

        • »
          »
          »
          »
          »
          3 часа назад, # ^ |
            Проголосовать: нравится 0 Проголосовать: не нравится

          Well, to be fair, it was an easier IQ problem. There are harder IQ problems out there, like that one B2 from a few contests ago. Though I'd classify that B2 as an IQish problem, not a full-on IQ problem. I was just letting the authors know that they made (whether on accident or on purpose) an IQ problem.

          The sad thing is that the IQish problems don't seem to go away completely as you search for higher-rated problems. There is no feeling like going to a problem's editorial and seeing that it was an IQ/IQish problem all along. Of course, there are worse feelings, like getting sent to hell probably, but there is no feeling quite like failing to solve an IQ problem.

          Also I think that your claim that you can't train for such problems is clearly ridiculous. Many GMs were stuck at Newbie for months and couldn't solve div.2 A-C. Has their IQ changed?

          Probably, because most of them started codeforces when they were like 12. On average, cognitive ability increases substantially from 12-25, but it mostly stops increasing by age 18. Show me the profile of one of these users, though. I'd be happy to be proven wrong.

          • »
            »
            »
            »
            »
            »
            2 часа назад, # ^ |
              Проголосовать: нравится 0 Проголосовать: не нравится

            According to Emory School of Medicine, "IQ is an abbreviation for Intelligence Quotient. “Intelligence,” as measured by IQ tests is rather narrowly defined. An IQ is intended as a predictor of the level of abilities a child will need to be successful in school. In the general population this score becomes relatively stable after about four years of age." So no, IQ doesn't generally change when you're an adolescent.

            Here are two profiles that I think have inspiring rating graphs.

            1. Bakry
            2. adamant his username fits his rating graph quite well in my opinion
            • »
              »
              »
              »
              »
              »
              »
              2 часа назад, # ^ |
                Проголосовать: нравится 0 Проголосовать: не нравится

              What they mean by that is that individuals' IQ scores generally stabilize by the age of 4. This means that, if a person scores 115 at age 4 (this is in reference to other 4-year-olds), they will likely score around 115 at age 34 (this is in reference to people around the age of 34). It doesn't mean that cognitive ability doesn't increase past 4. Of course a 34 year old is gonna be smarter than a 4 year old, on average.

              With that being said, I think that both of those users you have mentioned started way before they were 18. So they had lower cognitive ability when they started than they do now.

      • »
        »
        »
        »
        97 минут назад, # ^ |
          Проголосовать: нравится 0 Проголосовать: не нравится

        These are called "ad-hoc problems."

  • »
    »
    3 часа назад, # ^ |
      Проголосовать: нравится 0 Проголосовать: не нравится

    You are overusing the term IQ problem.

»
4 часа назад, # |
  Проголосовать: нравится +3 Проголосовать: не нравится

The given grid contains at most 1 connected region

missed the above statement in B, because my mind covered with the pictures in the statement , assumed there can be multiple components, because of which much time got wasted

»
4 часа назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

Amazing Contest! but I think there is a problem, rating changes applied to all participants even those whose rating greater than 2100 this could be a mistake maybe.

»
4 часа назад, # |
Rev. 2   Проголосовать: нравится +1 Проголосовать: не нравится

The B Question was not correctly framed.The ambiguity in the sentences were high.

»
4 часа назад, # |
Rev. 3   Проголосовать: нравится 0 Проголосовать: не нравится

Alternative approach to problem E.

I observed that, if we do not fight against monster i for some k = x, then we will not fight against it for k < x either. So I found the max k for each monster that would make them run away from the fight, and for each input if x <= res[i] then we do not fight with them. My proof was prayers, so anyone is welcome to either prove it right or wrong.

The rest is straight forward: We will do binary search for each monster. Let's take some fixed k. If we will not fight with monster i, then we have already fought with at least k*a[i] monsters out if first i-1. If that's the case then we should look for a greater k. Now we must be able to check how many of them we did not fight, meaning how many of them had res[j] >= k for j < i. We can do it with simple sum segment tree, keeping how many monsters had k = x in the leaf nodes.

The reason I cannot prove the first paragraph is that, when we check k < x, it's true that we will have more frequent level-ups, however it's also true that we will skip more monsters, so if we create an equation, both sides would be decreasing.

Accepted solution: 273561881

  • »
    »
    3 часа назад, # ^ |
    Rev. 2   Проголосовать: нравится 0 Проголосовать: не нравится

    A proof in plain language:

    Consider two ks, k_0<k_1, they walk in the sequence simultaneously.

    When k_0 levels up, k_1 still stays on the old level because more monster is required for him. This will result in k_0 skipping some monsters that k_1 fought.

    But that's fine because either k_1's level never catches up with k_0, or if it catches up, at that time k_0 already made some progress at that level, and now they will fight the same monsters.

    So k_1 can never fought more monsters than k_0 do.

  • »
    »
    3 часа назад, # ^ |
    Rev. 2   Проголосовать: нравится 0 Проголосовать: не нравится

    Another way to do this with a similar approach is store store an ordered multiset of all res[j] for j < i and find the order of key k.

»
4 часа назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

In Problem F, can anyone explains me this line how this would be the most optimal:

this is just checking that the minimum number of Fibonacci numbers used to represent an integer is equal to m .

»
3 часа назад, # |
Rev. 3   Проголосовать: нравится +1 Проголосовать: не нравится

I had a solution for problem E that's a bit simpler conceptually. (Doesn't require the harmonious series observation or changing the timeframe from i to k)

It's based on the following observation:

If a monster is fought when k=k_0, it will be fought when k is larger.

Given above, we can walk from position 1 to n, and maintain the number of monster fought for each k. For every new monster, based on observation, we only need to increase the count by 1 for a suffix. That can be done with BIT or your favorite range query data structures.

Now we still need to decide what's the smallest k for each position, or the which suffix should we operate on.

Again based on the observation, this can be found by binary search. When checking whether we will fight that monster for k, we make a query to our BIT to calculate the current level for k.

The overall complexity is still O(nlog^2n).

»
3 часа назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

A simpler implementation of C without stack/vector. 273589519

i thought of brackets reducing in pair of 2 and guessed by looking at pretest. although i am not very clear why this works and it would be great if someone could explain it.

»
3 часа назад, # |
  Проголосовать: нравится +3 Проголосовать: не нравится

Problem C can be solved in constant time and space with the formula len(s)/2 + 2*s.count(‘(‘) for an input string s, just have counter for open parenthesis and update as the input comes in.

If anyone has a good proof, I would be interested in seeing it.

»
3 часа назад, # |
Rev. 2   Проголосовать: нравится 0 Проголосовать: не нравится

i'm really curious and wanna know the linear $$$ O(n + m) $$$ of mine passes in ~$$$500ms$$$ but at the same time the binary search solutions having time complexity of $$$ O(n\log_2 n + m\log_2 n) $$$ pass in ~$$$200ms$$$.

»
3 часа назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

Solution For C

Spoiler
void solve(int T)
{
    int n;cin>>n;string s;cin>>s;
    int temp = 0;
    int ans = 0;
    for(int i=0;i<n;i++){
        temp++;
        if(s[i]==')'){
            ans += temp-1;
            ans += temp/2-1;
            temp = 0;
        }
    }
    cout<<ans<<endl;
}

»
2 часа назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

Can someone please explain why my question D doesn't work? I am just using basic DFS, and trying to find what the maximum value can I add to vertex 1. Submission: https://mirror.codeforces.com/contest/1997/submission/273756060

»
2 часа назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

can someone please explain the B problem, i really dont understand from either tutorial and vid soln

  • »
    »
    68 минут назад, # ^ |
      Проголосовать: нравится 0 Проголосовать: не нравится

    There are only two layouts in which blocking a cell creates 3 regions. Try brute forcing every cell and you will notice that only two layouts can be added to the answer.